Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/endpoint.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/endpoint.hpp	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/endpoint.hpp	(revision 4663)
@@ -947,4 +947,14 @@
     void transportClose(TransportId id) throw(Error);
 
+    /*************************************************************************
+     * Call operations
+     */
+    
+    /**
+     * Terminate all calls. This will initiate call hangup for all
+     * currently active calls.
+     */
+    void hangupAllCalls(void);
+    
     /*************************************************************************
      * Media operations
@@ -1123,4 +1133,64 @@
 
     static void on_buddy_state(pjsua_buddy_id buddy_id);
+    // Call callbacks
+    static void on_call_state(pjsua_call_id call_id, pjsip_event *e);
+    static void on_call_tsx_state(pjsua_call_id call_id,
+                                  pjsip_transaction *tsx,
+                                  pjsip_event *e);
+    static void on_call_media_state(pjsua_call_id call_id);
+    static void on_call_sdp_created(pjsua_call_id call_id,
+                                    pjmedia_sdp_session *sdp,
+                                    pj_pool_t *pool,
+                                    const pjmedia_sdp_session *rem_sdp);
+    static void on_stream_created(pjsua_call_id call_id,
+                                  pjmedia_stream *strm,
+                                  unsigned stream_idx,
+                                  pjmedia_port **p_port);
+    static void on_stream_destroyed(pjsua_call_id call_id,
+                                    pjmedia_stream *strm,
+                                    unsigned stream_idx);
+    static void on_dtmf_digit(pjsua_call_id call_id, int digit);
+    static void on_call_transfer_request(pjsua_call_id call_id,
+                                         const pj_str_t *dst,
+                                         pjsip_status_code *code);
+    static void on_call_transfer_request2(pjsua_call_id call_id,
+                                          const pj_str_t *dst,
+                                          pjsip_status_code *code,
+                                          pjsua_call_setting *opt);
+    static void on_call_transfer_status(pjsua_call_id call_id,
+                                        int st_code,
+                                        const pj_str_t *st_text,
+                                        pj_bool_t final,
+                                        pj_bool_t *p_cont);
+    static void on_call_replace_request(pjsua_call_id call_id,
+                                        pjsip_rx_data *rdata,
+                                        int *st_code,
+                                        pj_str_t *st_text);
+    static void on_call_replace_request2(pjsua_call_id call_id,
+                                         pjsip_rx_data *rdata,
+                                         int *st_code,
+                                         pj_str_t *st_text,
+                                         pjsua_call_setting *opt);
+    static void on_call_replaced(pjsua_call_id old_call_id,
+                                 pjsua_call_id new_call_id);
+    static void on_call_rx_offer(pjsua_call_id call_id,
+                                 const pjmedia_sdp_session *offer,
+                                 void *reserved,
+                                 pjsip_status_code *code,
+                                 pjsua_call_setting *opt);
+    static pjsip_redirect_op on_call_redirected(pjsua_call_id call_id,
+                                                const pjsip_uri *target,
+                                                const pjsip_event *e);
+    static pj_status_t
+    on_call_media_transport_state(pjsua_call_id call_id,
+                                  const pjsua_med_tp_state_info *info);
+    static void on_call_media_event(pjsua_call_id call_id,
+                                    unsigned med_idx,
+                                    pjmedia_event *event);
+    static pjmedia_transport*
+    on_create_media_transport(pjsua_call_id call_id,
+                              unsigned media_idx,
+                              pjmedia_transport *base_tp,
+                              unsigned flags);
 };
 
Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/media.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/media.hpp	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/media.hpp	(revision 4663)
@@ -126,5 +126,8 @@
 };
 
-typedef void* MediaPort;
+/**
+ * Media port, corresponds to pjmedia_port
+ */
+typedef void *MediaPort;
 
 /**
Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/siptypes.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/siptypes.hpp	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/siptypes.hpp	(revision 4663)
@@ -394,4 +394,5 @@
     unsigned		    usageCount;
 
+public:
     /** Construct from pjsua_transport_info */
     void fromPj(const pjsua_transport_info &info);
@@ -419,13 +420,15 @@
 
     /**
-     * Source IP address of the message.
-     */
-    string		srcIp;
-
-    /**
-     * Source port number of the message.
-     */
-    unsigned		srcPort;
-
+     * Source address of the message.
+     */
+    SocketAddress       srcAddress;
+
+    /**
+     * Pointer to original pjsip_rx_data. Only valid when the struct
+     * is constructed from PJSIP's pjsip_rx_data.
+     */
+    void               *pjRxData;
+
+public:
     /**
      * Construct from PJSIP's pjsip_rx_data
@@ -434,4 +437,196 @@
 };
 
+/**
+ * This structure describes an outgoing SIP message. It corresponds to the
+ * pjsip_tx_data structure in PJSIP library.
+ */
+struct SipTxData
+{
+    /**
+     * A short info string describing the request, which normally contains
+     * the request method and its CSeq.
+     */
+    string		info;
+    
+    /**
+     * The whole message data as a string, containing both the header section
+     * and message body section.
+     */
+    string		wholeMsg;
+    
+    /**
+     * Destination address of the message.
+     */
+    SocketAddress	dstAddress;
+    
+    /**
+     * Pointer to original pjsip_tx_data. Only valid when the struct
+     * is constructed from PJSIP's pjsip_tx_data.
+     */
+    void               *pjTxData;
+    
+public:
+    /**
+     * Construct from PJSIP's pjsip_tx_data
+     */
+    void fromPj(pjsip_tx_data &tdata);
+};
+
+/**
+ * This structure describes SIP transaction object. It corresponds to the
+ * pjsip_transaction structure in PJSIP library.
+ */
+struct SipTransaction
+{
+    /* Transaction identification. */
+    pjsip_role_e        role;           /**< Role (UAS or UAC)      */
+    string              method;         /**< The method.            */
+    
+    /* State and status. */
+    int			statusCode;     /**< Last status code seen. */
+    string		statusText;     /**< Last reason phrase.    */
+    pjsip_tsx_state_e	state;          /**< State.                 */
+    
+    /* Messages and timer. */
+    SipTxData           lastTx;         /**< Msg kept for retrans.  */
+    
+    /* Original pjsip_transaction. */
+    void               *pjTransaction;  /**< pjsip_transaction.     */
+    
+public:
+    /**
+     * Construct from PJSIP's pjsip_transaction
+     */
+    void fromPj(pjsip_transaction &tsx);
+};
+
+/**
+ * This structure describes timer event.
+ */
+struct TimerEvent
+{
+    TimerEntry          entry;          /**< The timer entry.           */
+};
+
+/**
+ * This structure describes transaction state changed event.
+ */
+struct TsxStateEvent
+{
+    struct
+    {
+        SipRxData       rdata;          /**< The incoming message.      */
+        SipTxData       tdata;          /**< The outgoing message.      */
+        TimerEntry      timer;          /**< The timer.                 */
+        pj_status_t     status;         /**< Transport error status.    */
+        GenericData     data;           /**< Generic data.              */
+    } src;                              /**< Event source.              */
+    SipTransaction      tsx;            /**< The transaction.           */
+    pjsip_tsx_state_e   prevState;      /**< Previous state.            */
+    pjsip_event_id_e    type;           /**< Type of event source:
+                                         *     - PJSIP_EVENT_TX_MSG
+                                         *     - PJSIP_EVENT_RX_MSG,
+                                         *     - PJSIP_EVENT_TRANSPORT_ERROR
+                                         *     - PJSIP_EVENT_TIMER
+                                         *     - PJSIP_EVENT_USER
+                                         */
+};
+
+/**
+ * This structure describes message transmission event.
+ */
+struct TxMsgEvent
+{
+    SipTxData           tdata;          /**< The transmit data buffer.  */
+};
+
+/**
+ * This structure describes transmission error event.
+ */
+struct TxErrorEvent
+{
+    SipTxData           tdata;          /**< The transmit data.         */
+    SipTransaction      tsx;            /**< The transaction.           */
+};
+
+/**
+ * This structure describes message arrival event.
+ */
+struct RxMsgEvent
+{
+    SipRxData           rdata;          /**< The receive data buffer.   */
+};
+
+/**
+ * This structure describes user event.
+ */
+struct UserEvent
+{
+    GenericData         user1;          /**< User data 1.               */
+    GenericData         user2;          /**< User data 2.               */
+    GenericData         user3;          /**< User data 3.               */
+    GenericData         user4;          /**< User data 4.               */
+};
+
+/**
+ * This structure describe event descriptor to fully identify a SIP event. It
+ * corresponds to the pjsip_event structure in PJSIP library.
+ */
+struct SipEvent
+{
+    /**
+     * The event type, can be any value of \b pjsip_event_id_e.
+     */
+    pjsip_event_id_e    type;
+    
+    /**
+     * The event body, which fields depends on the event type.
+     */
+    struct
+    {
+        /**
+         * Timer event.
+         */
+        TimerEvent      timer;
+        
+        /**
+         * Transaction state has changed event.
+         */
+        TsxStateEvent   tsxState;
+        
+        /**
+         * Message transmission event.
+         */
+        TxMsgEvent      txMsg;
+        
+        /**
+         * Transmission error event.
+         */
+        TxErrorEvent    txError;
+        
+        /**
+         * Message arrival event.
+         */
+        RxMsgEvent      rxMsg;
+        
+        /**
+         * User event.
+         */
+        UserEvent       user;
+        
+    } body;
+    
+    /**
+     * Pointer to its original pjsip_event. Only valid when the struct is
+     * constructed from PJSIP's pjsip_event.
+     */
+    void               *pjEvent;
+    
+public:
+    /**
+     * Construct from PJSIP's pjsip_event
+     */
+    void fromPj(const pjsip_event &ev);
+};
 
 //////////////////////////////////////////////////////////////////////////////
@@ -449,4 +644,5 @@
     string		subType;
 
+public:
     /**
      * Construct from PJSIP's pjsip_media_type
@@ -475,4 +671,5 @@
     string		hValue;
 
+public:
     /**
      * Initiaize from PJSIP header.
@@ -514,4 +711,5 @@
     string		body;
 
+public:
     /**
      * Initiaize from PJSIP's pjsip_multipart_part.
@@ -540,14 +738,14 @@
 {
     /**
-     * Optional remote target URI (i.e. Target header). If NULL, the target
-     * will be set to the remote URI (To header). At the moment this field
-     * is only used when sending initial INVITE and MESSAGE requests.
-     */
-    string		targetUri;
+     * Optional remote target URI (i.e. Target header). If empty (""), the
+     * target will be set to the remote URI (To header). At the moment this
+     * field is only used when sending initial INVITE and MESSAGE requests.
+     */
+    string                  targetUri;
 
     /**
      * Additional message headers to be included in the outgoing message.
      */
-    SipHeaderVector	headers;
+    SipHeaderVector         headers;
 
     /**
@@ -555,5 +753,5 @@
      * in this structure.
      */
-    string		contentType;
+    string                  contentType;
 
     /**
@@ -561,5 +759,5 @@
      * message doesn't have a body.
      */
-    string		msgBody;
+    string                  msgBody;
 
     /**
@@ -569,5 +767,5 @@
      * contains a body, the body will be added to the multipart bodies.
      */
-    SipMediaType	multipartContentType;
+    SipMediaType            multipartContentType;
 
     /**
@@ -577,6 +775,16 @@
      * the body will be added to the multipart bodies.
      */
-    SipMultipartPartVector	multipartParts;
-
+    SipMultipartPartVector  multipartParts;
+
+public:
+    /**
+     * Check if the options are empty. If the options are set with empty
+     * values, there will be no additional information sent with outgoing
+     * SIP message.
+     *
+     * @return              True if the options are empty.
+     */
+    bool isEmpty() const;
+    
     /**
      * Initiaize from PJSUA's pjsua_msg_data.
@@ -590,4 +798,5 @@
 };
 
+//////////////////////////////////////////////////////////////////////////////
 
 /**
@@ -600,10 +809,10 @@
      * MIME type. Default is "text/plain".
      */
-    string contentType;
+    string      contentType;
     
     /**
      * The message content.
      */
-    string content;
+    string      content;
     
     /**
@@ -611,9 +820,15 @@
      */
     SipTxOption txOption;
-
+    
     /**
      * User data, which will be given back when the IM callback is called.
      */
-    Token userData;
+    Token       userData;
+    
+public:
+    /**
+     * Default constructor initializes with zero/empty values.
+     */
+    SendInstantMessageParam();
 };
 
@@ -628,10 +843,16 @@
      * True to indicate to remote that local person is currently typing an IM.
      */
-    bool isTyping;
+    bool         isTyping;
     
     /**
      * List of headers etc to be included in outgoing request.
      */
-    SipTxOption txOption;
+    SipTxOption  txOption;
+    
+public:
+    /**
+     * Default constructor initializes with zero/empty values.
+     */
+    SendTypingIndicationParam();
 };
 
Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/types.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/types.hpp	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2/types.hpp	(revision 4663)
@@ -74,4 +74,14 @@
 typedef void *TransportHandle;
 
+/**
+ * Timer entry, corresponds to pj_timer_entry
+ */
+typedef void *TimerEntry;
+
+/**
+ * Generic data
+ */
+typedef void *GenericData;
+
 /*
  * Forward declaration of Account to be used
@@ -211,4 +221,27 @@
 };
 
+//////////////////////////////////////////////////////////////////////////////
+
+/**
+ * Representation of time value.
+ */
+struct TimeValue
+{
+    /**
+     * The seconds part of the time.
+     */
+    long sec;
+    
+    /**
+     * The miliseconds fraction of the time.
+     */
+    long msec;
+    
+public:
+    /**
+     * Convert from pjsip
+     */
+    void fromPj(const pj_time_val &prm);
+};
 
 } // namespace pj
